#include "WProgram.h"
/*
 
 
 */




//these are to set the serial protocol driver speed

#define OSX 1
#define WIN 0
#define LINUX 0


//------------------------------------------------------------------------------------------
// Button typedefs

void init_buttons_driver();
void toggleAllButtons();
void populate_buttons ();
byte get_button_states();
void pulse_pin(int pin_number);
byte clear_lsb(byte byte_to_clear);
void buttonInit(void);
void buttonCheck(byte row, byte index);
void check_and_send_buttons(void);
void displayInit();
void updateLED();
void clearAllLights();
void lightAllLed();
void toggleLed(int x, int y);
void setLed(int x, int y);
void clearLed(int x, int y);
void initInterrupt();
void setup ();
void loop ();
void protocolRun();
void setISRtimer();
void startISR();
void stopISR();
byte button_current[8];
byte button_last[8];
byte button_state[8];
byte button_event[8];

void init_buttons_driver();

//function to read the state and populate the button array's
void populate_buttons();


//------------------------------------------------------------------------------------------
// Display typedefs
byte ledmem[8];                         // memory for LEDs

//initiates variables and such
void displayInit();

//main loop update thingy
void updateLED();
//utility function to wipe the screen
void clearAllLights();


#define pin_button_data  10
#define pin_button_clock  9
#define pin_button_apl  8

#define pin_button_latch  pin_button_apl

void init_buttons_driver()
{
  pinMode(pin_button_latch, OUTPUT);
  pinMode(pin_button_clock, OUTPUT); 
  pinMode(pin_button_data, INPUT);
}

void toggleAllButtons() //will swap all the bytes, the hardware I use gives 1 as default
{

   for (int I = 0; I < 8; I++)
   for (int y  = 0; y < 8; y++)
      button_current[I]  ^= (1 << (7-y));
}


//function to read the state and populate the button array's
void populate_buttons () {
  
    for (int i = 0; i < 8; i++)
      button_last [i] = button_current [i]; 


   pulse_pin(pin_button_latch); // sample the button states

 for (int I = 0; I < 8; I++)
  button_current[I]= get_button_states();
  toggleAllButtons();
}


byte get_button_states(){
  byte my_bit;
  byte button_byte;

  button_byte=0; // clear the byte ready for new data
  for (int n=0; n<8; n++){
    button_byte = button_byte << 1 ; // shift bits to the left, making space to capture the state of the next button
    button_byte=clear_lsb(button_byte); // make sure the new lsb is zero, to avoid surprises
    my_bit = digitalRead(pin_button_data); // store the current Q7 value from the button register in my_bit 
    button_byte = button_byte | my_bit; // OR th my_input with the new bit to add it to the lsb 
    pulse_pin(pin_button_clock); // cue the next bit slot for reading
  }
  return(button_byte);
}


// Set a pin to low, then high
void pulse_pin(int pin_number){
  digitalWrite(pin_number,LOW);
  //delayMicroseconds(20);
  digitalWrite(pin_number,HIGH);
}

// Clear the least significant bit
byte clear_lsb(byte byte_to_clear){
  return(byte_to_clear & 0xfe);  // AND the byte with 11111110 to be sure that the LSB is zero
}

 

#define kButtonUpDefaultDebounceCount    12
#define kButtonNewEvent    1
#define kButtonNoEvent     0

byte button_debounce_count[8][8];

void buttonInit(void){
  byte i;
  for (i = 0; i < 8; i++) {
    button_current[i] = 0x00;
    button_last[i] = 0x00;
    button_state[i] = 0x00;
    button_event[i] = 0x00;
  }

  init_buttons_driver();
}


void buttonCheck(byte row, byte index)
{
  if (((button_current[row] ^ button_last[row]) & (1 << index)) &&   // if the current physical button state is different from the
  ((button_current[row] ^ button_state[row]) & (1 << index))) {  // last physical button state AND the current debounced state

    if (button_current[row] & (1 << index)) {                      // if the current physical button state is depressed
      button_event[row] = kButtonNewEvent << index;              // queue up a new button event immediately
      button_state[row] |= (1 << index);                         // and set the debounced state to down.
    }
    else{
      button_debounce_count[row][index] = kButtonUpDefaultDebounceCount;
    }  // otherwise the button was previously depressed and now
    // has been released so we set our debounce counter.
  }
  else if (((button_current[row] ^ button_last[row]) & (1 << index)) == 0 &&  // if the current physical button state is the same as
  (button_current[row] ^ button_state[row]) & (1 << index)) {        // the last physical button state but the current physical
    // button state is different from the current debounce 
    // state...

    if (button_debounce_count[row][index] > 0 && --button_debounce_count[row][index] == 0) {  // if the the debounce counter has
      // been decremented to 0 (meaning the
      // the button has been up for 
      // kButtonUpDefaultDebounceCount 
      // iterations///

      button_event[row] = kButtonNewEvent << index;    // queue up a button state change event

      if (button_current[row] & (1 << index)){          // and toggle the buttons debounce state.
        button_state[row] |= (1 << index);
      }
      else{
        button_state[row] &= ~(1 << index);
      }
    }
  }
}



void check_and_send_buttons(void)
{
  int b = 0;

  for(int i = 0; i < 8; i++)
  {

    for(int id = 0; id < 8; id++) 
    {

      buttonCheck(i, id);

      if (button_event[i] & (1 << id)) 
      {
        button_event[i] &= ~(1 << id);
        if(button_state[i] & (1 << id))
        {
          b = 1;
        }
        else
        {
          b = 0;
        }
        //  toggleLed(7,0); den h\u00e4r fungerar ju!
        //     Serial.print((0 << 4) | (b & 15), BYTE);
        //   Serial.print((id << 4) | (i & 15), BYTE);
        Serial.println((0 << 4) | (b & 15), DEC);
        Serial.println(id, DEC);
        Serial.println(i, DEC);

      }
    }
  }
}


//Pin connected to ST_CP of 74HC595
#define latchPin  11
//Pin connected to SH_CP of 74HC595
#define  clockPin  12
////Pin connected to DS of 74HC595
#define  dataPin  13

/* This is correct, however there seems to be some kind of bug in my shiftout so I've flipped the pins here instead :) DIRTY FIX
 int ledCol[8] = {
 7,6,5,4,
 //analog
 14,15,16,17  };
 */
int ledCol[8] = {  
  17,7,6,5,4,14,15,16  }; //did I mention this was a dirty fix?




void displayInit()
{
  for (int i = 0; i < 8; i++)
    pinMode(ledCol[i], OUTPUT);

  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT); 
  pinMode(dataPin, OUTPUT);



}

//main loop update thingy
void updateLED()
{

  for (int I = 0; I < 8; I++)
  {
    digitalWrite(ledCol[I],LOW); //turning our current column on first on!

    digitalWrite(latchPin, LOW);
    shiftOut(dataPin, clockPin, LSBFIRST,ledmem[I]);   

    //return the latch pin high to signal chip that it 
    //no longer needs to listen for information
    digitalWrite(latchPin, HIGH);
    digitalWrite(ledCol[I],HIGH); //turning the current column it off!

  }



}

//utility function to wipe the screen

void clearAllLights()
{
  for (int I = 0; I < 8; I++)
    ledmem[I]=0;
}

void lightAllLed()
{
  for (int I = 0; I < 8; I++)
    ledmem[I]=255;
}

void toggleLed(int x, int y)
{  
  ledmem[x]  ^= (1 << (7-y));
}

void setLed(int x, int y)
{
  ledmem[x] |= (1 << (7-y));
}


void clearLed(int x, int y)
{
  ledmem[x]  &= ~(1 << (7-y));
}





void initInterrupt()

{

  // Set up 8-bit counter 2, output compare switched off,
  // normal waveform generation (whatever that might mean)
  TCCR2A = 0;
  // set counter to be clocked at 16Mhz/8 = 2Mhz
  TCCR2B = 1<<CS21;

  // set the interrupt mask so that we get an interrupt
  // on timer 2 overflow, i.e. after 256 clock cycles.
  // The timer 2 interrupt routine will execute every
  // 128 uS.
  TIMSK2 = 1<<TOIE2;

  // NOTE: In my efforts to try to get this
  // code to work reliably at 115200 baud
  // I went about disabling unused timers that
  // are set up by the Arduino framework.
  // The framework sets up both timer 2 and 
  // timer 1.  We use timer 2 to drive the
  // serial reading interrupt, so we can only
  // disable timer1 and its interrupt.

  // REALLY IMPORTANT NOTE - IF YOU WANT TO USE
  // ANALOGWRITE

  // Disabling timer 1 will switch off the timer
  // used for PWM, which underlies analogWrite.
  // If you want to use analogWrite, remove
  // the lines below.

  // DISABLE PWM COUNTER
  TIMSK0 &= ~(1 << TOIE0);

  TCCR1B &= ~(1 << CS12);
  TCCR1B &= ~(1 << CS11);
  TCCR1B &= ~(1 << CS10);  
  // END DISABLE PWM COUNTER

  // Also, disable the interrupts on timer 0
  // REALLY IMPORTANT NOTE IF YOU WANT TO USE
  // DELAY
  // remove this line, and also look at
  // 'whoosh', which enables and then disables
  // the intterupt on timer 0.  You'll want
  // to get rid of those lines too.
  TIMSK0 &= ~(1 << TOIE0);


}

ISR(TIMER2_OVF_vect) {

  // goProtocol();

}

void setup () 
{
  Serial.begin(9600);

  buttonInit();  
  displayInit();

  clearAllLights();
  setISRtimer();
  startISR();
}  


void loop () 
{
  populate_buttons();
  protocolRun();
  check_and_send_buttons();  
}


//interrupt
#define ISR_FREQ 170     //740Hz        // Sets the speed of the ISR - LOWER IS FASTER 


void protocolRun()
{
  sei(); 
  if (Serial.available()>=3)
  {
    int val;

    val = Serial.read();      // read the serial port
    if (val=='1') //set Led
    {    
      setLed(Serial.read()-48,Serial.read()-48);
    }
    else if (val=='0') //clear Led
    {    
      clearLed(Serial.read()-48,Serial.read()-48);
    }
    else if (val=='2') //toggleLed
    {    
      toggleLed(Serial.read()-48,Serial.read()-48);
    }

    else if (val=='3') //ligth column
    {    
      //toggleLed(Serial.read()-48,Serial.read()-48);
    }

    else if (val=='43') //dark column
    {    
    //  toggleLed(Serial.read()-48,Serial.read()-48);
    }
    else if (val=='5') //toggle column
    {   
     //toggle leds in column  
     int column= Serial.read()-48;
     Serial.read()-48;
       for(int i=0;i<8;i++)
        toggleLed(i,column);
    }


    else if(val=='6')
    {
      int a=Serial.read();int b=Serial.read();
      if (a=='0')
         clearAllLights();
      if (a=='1')
         lightAllLed();
         
    }
  } 
}


ISR(TIMER2_COMPA_vect) {  //Called when ISR triggers
  // protocolRun();
  updateLED();

}  

void setISRtimer(){  // setup ISR timer 
  TCCR2A = (1<<WGM21);                  // WGM22=0 + WGM21=1 + WGM20=0 = Mode2 (CTC)
  TCCR2B = (1<<CS22)|(0<<CS21)|(1<<CS20);  // set prescaler to /128(125kHz)
  TCNT2 = 0;                                      //clear counter
  OCR2A = ISR_FREQ;                        // set TOP (divisor) - see #define
}

void startISR(){  // Starts the ISR
  TIMSK2=(1<<OCIE2A);                     // set interrupts=enabled (calls ISR(TIMER2_COMPA_vect)
}

void stopISR(){    // Stops the ISR
  TIMSK2=(0<<OCIE2A);                    // disable interrupts
} 



int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

